#include "common.h"

int debug_level = 0;

int main( int argc, char **argv, char **envp ) {
   char sopt[] = "d:l:v";
   int c, n, mdelay = 50, nlen = 10;;
   float ku = 1.0;
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 'd':
            mdelay = atoi( optarg );
            break;
         case 'l':
            nlen = atoi( optarg );
            break;
         case 'v':
            debug_level++;
            break;
         default :
            fprintf( stdout, "допустимые опции: %s\n", sopt );
            return( EXIT_FAILURE );
      }
   while( 1 ) {
      char buf[ 80 ], cmd[] = "*?=hq";
      int new_val = 0, cur_val;
      fprintf( stdout, "команда (h-подсказка): " );
      fflush( stdout );
      fgets( buf, sizeof( buf ) - 1, stdin );
      if( NULL == index( cmd, buf[ 0 ] ) ) {
         fprintf( stdout, "нераспознанная команда!\n" );
         continue; 
      }
      else n = index( cmd, buf[ 0 ] ) - (char*)cmd;
      switch( n ) {
         case 0: 
            sscanf( buf + 1, "%f", &ku );
            if( debug_level > 0 ) fprintf( stdout, "усиление = %3.1f\n", ku );
            continue;
         case 1: 
            fprintf( stdout, "текущее значение = %d\n", get_value() );
            continue;
         case 2: 
            sscanf( buf + 1, "%d", &new_val );
            if( debug_level > 0 ) fprintf( stdout, "новое значение = %d\n", new_val );
            if( new_val == get_value() ) continue;
            break;
         case 4: 
            return( EXIT_SUCCESS );
         case 3: 
         default :
            fprintf( stdout, "реализованные команды: " );
            for( n = 0; n < sizeof( cmd ) / sizeof( cmd[ 0 ] ); n++  )
               fprintf( stdout, "%c ", cmd[ n ] );
            fprintf( stdout, "\n" );
            continue;
      }      
      n = 0;
      while( 1 ) {
         int cur_val = get_value(),
             delta = new_val - cur_val, istep;
         float step = ku * delta;
         struct timespec msec; // = { 0, 0 };   // пассивная задержка в msec.
         if( fabs( step ) < 1.0 ) break;
         if( n++ > nlen ) break;
         istep = (int)floor( fabs( step ) + .5 ) * ( step >= 0. ? 1 : -1 );
         if( debug_level > 0 ) fprintf( stdout, "%d%+d  ", cur_val, istep );
         do_step( istep );
         msec.tv_sec = 0; msec.tv_nsec = mdelay;
         nanosleep( &msec, NULL );
      }
      if( debug_level > 0 ) fprintf( stdout, "\n" );

   }
}

